/**
 * Created by yantianyu on 2015/1/16.
 */
var main={},
    PhaseType = {
        MiddleSchool: 141,
        HighSchool: 142
    },
    QuestionType = {
        SingleChoice: 0,                 //单选题
        ShortAnswer: 1,                 //填空题
        MultiChoice:2,                  //多选题
        LongAnswer:3,                   //主观题
        ReadingComprehension : 4,       //阅读理解
        Cloze:5,                        //完形填空
        EnglishWord: 456                //英语单词题
    },
    SubjectType = {
        Math: 103,
        English: 104
    },
    StyleMode = {
        DayMode:'0',                //日间模式
        Night: '1'                  //夜间模式
    },
    cfgSet={
        style:[
            "",                     //未答
            "finished",             //已答
            "SelectWrong",          //答错
            "SelectRight",           //答对
            'active'                //高亮
        ]
    };

main={
    onNativeMessage:function(msg_id, msg_content){
        switch(msg_id){
            case "client_msg_completion_mark_blank_status":
                for(var i=0;i<msg_content.indexes.length;i++){
                    $(".question .underline span").eq(msg_content.indexes[i])[0].className=cfgSet.style[msg_content.status[i]];
                }
                break;
            case "client_msg_completion_focus_blank":
                $(".question .underline span").removeClass("active").removeClass("activeMark");
                // alert($(".question .underline span").eq(msg_content.index)[0].className);
                //下面的判断条件：若class中既没有SelectRight，SelectWrong,finished，则条件为真
                if($(".question .underline span").eq(msg_content.index).hasClass("SelectRight") || $(".question .underline span").eq(msg_content.index).hasClass("SelectWrong") || $(".question .underline span").eq(msg_content.index).hasClass("finished")) {
                    $(".question .underline span").eq(msg_content.index).addClass("activeMark");
                }else{
                    $(".question .underline span").eq(msg_content.index)[0].className = cfgSet.style[4];
                }
                break;
            case "client_msg_completion_scroll_to_blank":
                $.scrollTo({
                    endY: -document.documentElement.clientHeight/2+$(".underline > span").eq(msg_content.index).offset().top,
                    duration: 500,
                    callback: function() {
                        //alert('at the top');
                    }
                });
                break;
            case "client_msg_style_mode":
                if(msg_content.style_mode=="day_mode" ){
                    StyleModeChange.dayMode();
                }else{
                    StyleModeChange.nightMode();
                }
                break;
            default :break;
        }
    },

    spanClicked:function(){
        $(".question .underline").bind("click",function(){
            JSNativeBridge.send("js_msg_completion_user_click_blank",{"index":$(".question .underline").index(this)});
        });
    },

    init:function(){
        main.spanClicked();
        if(config.styleMode == "night_mode"){
            StyleModeChange.nightMode();
        }else{
            StyleModeChange.dayMode();
        }
    },

    load:function(){
        main.init();
        JSNativeBridge.init(main.onNativeMessage);
    }
};

main.load();
//JSNativeBridge.postNativeMessage("client_msg_completion_mark_blank_status",encodeURIComponent(JSON.stringify({"indexes":['0','1','2','3'],"status":['1','2','3','4']})));
//JSNativeBridge.postNativeMessage("client_msg_completion_focus_blank",encodeURIComponent(JSON.stringify({"index":'6'})));

