var main;
var setting = {
	/*气泡的显示时间，超过时间自动消失，设置为false不消失*/
	showTimes : 800
};

main = {
	load : function() {
        if(config.isShowPracBtn=="false"){
            $(".practice_knowledge").hide();
        }
        JSNativeBridge.init(main.onNativeMessage);
		this.ev();
	},
	ev : function() {
		this.accordion();
		this.bind();
        this.practiceClicked();
	},
	accordion : function() {
		$('.accordion .title').bind('click', function () {
			$(this).find("div").toggleClass("div_hover");
			$(this.parentNode).find("article").toggle();
		});
	},
    practiceClicked:function(){
        $(".practice_knowledge").click(function(){
            JSNativeBridge.send("js_msg_practice_knowledge",{"knowledage_id": config.knowledgeId});
        });
    },
	bind : function() {
        var understood = 1, misunderstood = 0, unknown = -1;
		$(".good").click(function() {
			var selfStatus = understood;
			if($(this).hasClass('mark')) selfStatus = unknown;
            main.toggleKnowledgeStatus(selfStatus);
            window.uplusInterface.setKnowledgeStatus(selfStatus);
		});
		
        $(".bad").click(function() {
        	var selfStatus = misunderstood;
			if($(this).hasClass('mark')) selfStatus = unknown;
            main.toggleKnowledgeStatus(selfStatus);
            window.uplusInterface.setKnowledgeStatus(selfStatus);
        });
        
        $("body").on('click', 'img', function(e) {
            if(/android_asset\/images/.test($(this).attr("src"))){                   //if(/bulb_bright\.png|bulb\.png|discuss\.png|favor\.png|unfavor\.png/.test($(this).attr("src"))){
                return;
            }
        	var _this = this;
            var imgFile = this.src;
            if(!this.show){
                if(imgFile.indexOf('file://') == 0) {
                    imgFile = imgFile.substr('file://'.length);
                };

                if(imgFile.indexOf('?')){
                    imgFile = imgFile.split('?')[0]
                };
                //防止快速重复点击img
                this.show = 1;
                window.uplusInterface.zoomImage( imgFile );
                setTimeout(function(){
                    _this.show=0;
                },2000)
            }
        });
        
        $(".reloading").on('click', function(e) {
        	uplusInterface.reload(); 
        })
	},

    toggleKnowledgeStatus : function(selfStatus) {
        $(".good").removeClass('mark');
        $(".bad").removeClass('mark');

        if(selfStatus > 0) {
            $(".good").addClass('mark');
        } else if(selfStatus == 0){
            $(".bad").addClass('mark');
        }
    },
	/*
	*返回是否是显示状态的布尔值  =>true,false;
	*/
	isShow : function() {
		return !($(".tip-bubble").hasClass("hide"));
	},

    setUserMasteries : function(selfStatus) {
        this.toggleKnowledgeStatus(selfStatus);
    },
	
	setMasteriesCount  : function(understoodNum, misunderstoodNum) {
		$(".good .num").text(understoodNum);
        $(".bad .num").text(misunderstoodNum);
	},

    onNativeMessage: function(msg_id, msg_content) {
        switch(msg_id) {
            case "client_msg_style_mode":
                if(msg_content.style_mode==0 || msg_content.style_mode=='0' ){
                    StyleModeChange.dayMode();
                }else{
                    StyleModeChange.nightMode();
                }
                break;
            default:
                break;
        }
    }
};
