var main={},
    common={},
    ev={},
    tag = 0, //如果 getResult() 一次，这个标志就置 1 了
    PhaseType = {
        MiddleSchool: 141,
        HighSchool: 142
    },
    QuestionType = {
        SingleChoice: 0,                 //单选题
        ShortAnswer: 1,                 //填空题
        MultiChoice:2,                  //多选题
        LongAnswer:3,                   //主观题
        ReadingComprehension : 4,       //阅读理解
        Cloze:5,                        //完形填空
        EnglishWord: 456                //英语单词题
    },
    SubjectType = {
        Math: 103,
        English: 104
    },
    StyleMode = {
        DayMode:'0',                //日间模式
        Night: '1'                  //夜间模式
    },
    cfgSet=(function(){
        var cfgSet={style : {
            //正确错误的样式
                wrong : 'androidSelectWrong',//'color:#fff;background:#f05836;box-shadow:inset 1px 1px 1px #cc6633',
                right : 'androidSelectRight',//'color:#fff;background:#4cae68;box-shadow:inset 1px 1px 1px #339966',
                iptWrong : 'iptWrong',//'borderColor':'#323232','color':'#f05836'
                iptRight : 'iptRight',//'borderColor':'#4cae68','color':'#1d4b2a'
                active : 'active'
            }
        };
        if(devJudge.isIOS()){
            cfgSet.style.wrong='IOSSelectWrong';
            cfgSet.style.right='IOSSelectRight';
        }
        return cfgSet;
    })();

common = {
    //激活当前一个的class共用方法
    activeOne : function(one,all,active){
        for(var i=0; i<all.length; i++)all[i].className = '';
        one.addClass(active);
    },
    showAnaByLA:function(){
        $(".show_analysis").addClass("hover");
        $(".show_analysis > span").eq(0).text("题目解析").off();
        $(".show_analysis .discuss").removeClass("none");
    },
    toTrimDBC : function (Str) {
        var DBCStr = "";
        for(var i=0; i<Str.length; i++){
            var c = Str.charCodeAt(i);
            if(c == 12288 ||c == 32) {
                continue;
            };
            if(c == 65123 || c==8212){
                DBCStr += '-';
                continue;
            };
            if (c > 65280 && c < 65375) {
                DBCStr += String.fromCharCode(c - 65248);
                continue;
            };
            DBCStr += String.fromCharCode(c);
        };
        return DBCStr.replace(/\"*\'*\<*\>*/gi,'');
    }
};

ev = {
    //返回图片结果
    initImg : function(){
        var isMove=false;
        $('body').delegate('img','touchend',function(){
            if(/android_asset\/images/.test($(this).attr("src"))){                   //if(/bulb_bright\.png|bulb\.png|discuss\.png|favor\.png|unfavor\.png/.test($(this).attr("src"))){
                return;
            }
            if(!isMove){
                var _this = this;
                var imgFile = this.src;
                if(!this.show){
                    if(imgFile.indexOf('file://') == 0) {
                        imgFile = imgFile.substr('file://'.length);
                    };

                    if(imgFile.indexOf('?')){
                        imgFile = imgFile.split('?')[0]
                    };
                    //防止快速重复点击img
                    this.show = 1;
                    main.opt.zoomImg( imgFile );
                    setTimeout(function(){
                        _this.show=0;
                    },2000)
                }
            }
            isMove=false;
        });
        $('body').delegate('img','touchmove',function(){
            isMove=true;
        });
    },
    //点击canvas返回图片
    initCanvas:function(){
        var isMove=false;
        $('body').delegate('canvas','touchend',function(){
            var $targetImg=$(this).prev();
            if(/android_asset\/images/.test($($targetImg).attr("src"))){
                return;
            }
            if(!isMove){
                var imgFile = $targetImg[0].src;
                if(!$targetImg[0].show){
                    if(imgFile.indexOf('file://') == 0) {
                        imgFile = imgFile.substr('file://'.length);
                    };

                    if(imgFile.indexOf('?')){
                        imgFile = imgFile.split('?')[0]
                    };
                    //防止快速重复点击img
                    $targetImg[0].show = 1;
                    main.opt.zoomImg( imgFile );
                    setTimeout(function(){
                        $targetImg[0].show=0;
                    },2000)
                }
            }
            isMove=false;
        });
        $('body').delegate('canvas','touchmove',function(){
            isMove=true;
        });
    },
    //手风琴
    accordion : function(){
        $('.accordion h4 p').bind('click',function(){
            var _this = $(this);
            var _thisImg=_this.children("img");
            var contentElem = $(this.parentNode.nextElementSibling);
            if(!contentElem.hasClass('knowledge_points')) {
                _this.toggleClass('p_hover');
                if(_this[0].className=="p_hover"){
                    //_thisImg.attr("src",_thisImg.attr("src").replace(/bulb_bright\.png/,"bulb.png"));
                    _thisImg.eq(0).hide();
                    _thisImg.eq(1).show();
                }else{
                    //_thisImg.attr("src",_thisImg.attr("src").replace(/bulb\.png/,"bulb_bright.png"));
                    _thisImg.eq(1).hide();
                    _thisImg.eq(0).show();
                }
                contentElem.toggle();
            }
            main.opt.analysClick( this.parentNode.className ,(!_this.hasClass('p_hover')).toString() );
        });
        //用户点击最后一个选项卡的时候要展示其选项卡下所有内容，否则用户不知道下面有东西;
        //TODO这个因为一个元素绑定了两事件，所以在FF内核中可能存在执行顺序问题
        $(".accordion").last().find("h4 p").bind("click",function(){
            !$(this).hasClass("p_hover") && (document.body.scrollTop = 10000000000000);
        })
    },

    liClick : function(arg){
        var elem = $('.answer li');
        function fn(ev){
            main.makeResult($(this),ev);
            if(!main.isExamination) {
                elem.off('click', fn);
            }
        }
     	elem.on('click',fn);
    },

    liTouch:function(arg){
        var elem = $('.answer li');
        var isTouchMove=false;
        var activeObj=null;
        elem.on('touchstart',function(){
            $(this).addClass("ans_touched");
            isTouchMove=false;
            activeObj=null;
        }).on('touchend',function(ev){
            ev.stopPropagation();
            $(this).removeClass("ans_touched");
            if(isTouchMove){
                if(!activeObj){
                    isTouchMove=false;
                    return;
                }else{
                    activeObj[0].className="active";
                }
            }
            if(!isTouchMove) {
                $(this).parents("ul").find("a").removeClass("active");
                $(this).find("a")[0].className = "active";
                main.makeResult($(this), ev);
                if (!main.isExamination) {
                    elem.off();
                }
            }
            isTouchMove=false;
            activeObj=$(".active");
        }).on('touchmove',function(){
            isTouchMove=true;
            $(this).removeClass("ans_touched");
        });
    },

    sendFeedback : function(){
        var eFB = $('.feedback, .show_analysis .discuss');
        eFB.bind("click",function(){
            $('#discuss_tip').hide();
            main.opt.sendFeedback();
            try{
                $(".notifyforxueba").remove();
            }catch(e){}
        });
    },
    viewKnowledge: function() {
    	$(".knowledge_point").on('click', function(elem) {
    		main.opt.viewKnowledge(elem.target.id);
    	})
    }
};

main = {
    exports : {
        result : -1,//如果没有被选择，直接返回负一
        answerContent :
        {
            type : 0,
            userSelectedIndex : [''],
            rightSelectedIndex : [''],
            answer : ['']
        }
    },
    rangeDom : function(){

        var a = $('#topic_header'),b = a.next();
        if(b.html()!='') {                      //b.length>0 几个空格算文本节点，则b.length不为0
            b && a.prependTo(b);
        }
        if( main.is_analysis || !main.isExamination ){
            //清除在答题解析里面头部和尾部的多余P标签
            var aDiv = $('.contentInfo .accordion > article > div');
            aDiv.forEach(function(e){
                try{
                    var text = $(e).text().trim(),
                        imgs = $(e).find('img');
                    if( (text  === "null" || text == "") && imgs.length == 0)$(e).closest(".accordion").hide();
                }catch(e){}
                var aP = $(e).find('p');
                for(var i=aP.length-1; i>=0; i--){
                    if( aP[i].innerHTML === '' || aP[i].innerHTML === '&nbsp;'){
                        aP[i].style.display='none'
                    }else{
                        break;
                    }
                };
            });
            aDiv.forEach(function(e){
                var aP = $(e).find('p');
                for(var i=0; i<aP.length; i++){
                    if( aP[i].innerHTML === '' || aP[i].innerHTML === '&nbsp;'){
                        aP[i].style.display='none'
                    }else{
                        break;
                    }
                }
            });
        }

    },
    resizeImg : function(){
        $('img').each(function(index, elem) {
            if(/android_asset\/images\//.test($(this).attr("src"))){       //if(/bulb_bright\.png|bulb\.png|discuss\.png|favor\.png|unfavor\.png/.test($(this).attr("src"))){
                return;
            }
            var img = new Image();
            img.onload = function() {
                elem.style.position = 'static';
                elem.style.height = (img.height / 2 + 4) + 'px';
                delete img;
            }
            img.src = elem.src;
        })

        try{
        }catch(e){

        };
    },

    resizeEqSymbol: function() {
      var divs = $('*[muststretch]').parent();
        divs.each(function(index, divElem){
            var div = $(divElem),
                    h = div.parent().height(),
                    w = div.parent().width(),
                    h1 = 0,
                    w1 = 0;

            div.find('*:not([muststretch])').each(function(i, elem){
                h1 += $(elem).height();
                w1 += $(elem).width();
            })

            vDivs = div.find('*[muststretch=v]');
            vDivs.each(function(i, elem){
                $(elem).height((h -h1) / vDivs.size())
            })

            hDivs = div.find('*[muststretch=h]');
            hDivs.each(function(i, elem){
                $(elem).width((w -w1) / hDivs.size())
            })
        })
    },

    makeResult : function(target, ev){
        ev.stopPropagation();
        var rightJson = '',index,right;
        //正确的索引
        var rightSelectedIndex = $('.answer ul li.right').index();//$('.answer ul li').toArray().map(function(e){ return $(e).is('.right')});
        if(!main.isExamination && tag && (rightSelectedIndex == $('a.active').closest('li').index()) ){ //如果上次选过 而且选择是正确的
            return;
        };

        //用户选择的索引
        var userSelectedIndex = target.index();//$('.answer ul li span :first-child').toArray().map(function(e){ return $(e).is('.active')})
        //将当前答案对错的标志保存
        right = userSelectedIndex == rightSelectedIndex ? 1 : 0;
        //当前的索引
        index = target.find('a').html();
        common.activeOne( target.find('a') , $('.answer').find('a') ,'active');
        main.exports = {
            result : right,
            answerContent : {
                type : 0,
                userSelectedIndex : userSelectedIndex,
                rightSelectedIndex : rightSelectedIndex,
                answer : right
            }
        };
        main.opt.onUserAnswered(JSON.stringify( main.exports ))
        if(!main.isExamination) {
            if(right) {
               $('.answer ul li.right a')[0].className = cfgSet.style.right;
                main.showAnalysis(main.exports.answerContent);
            }else {
                main.showAnalysis(main.exports.answerContent);
                if(main.problemType != QuestionType.EnglishWord) {
                    main.scrollToAnalysis();
                }
            }

            main.bindForAnalysis();
        }
    },
    makeInputResult : function(){
        var result = {}, right = [],wrong = corre = 0, answerUser=[], answerAll=[], rightAnswer = $(".answer ul li .contentInner"), aIpt = $('.question input');
        aIpt.each(function(i,e){
            var ipt = common.toTrimDBC( $(aIpt[i]).val()), //将全角的转换成半角进行判断
                rA;
            try{rA = common.toTrimDBC( ($(rightAnswer[i]).text().trim()).slice(1) );}catch(e){rA = 'error'} //也要转化成半角的
            if( ipt!='' && rA!='' && (ipt.trim() == rA.trim()) ){
                corre++;
                right.push(1);
            }else{
                wrong++;
                right.push(0);
            };
            answerAll.push( rA )
            answerUser.push( ipt );
        });
        main.exports =
        {
            result : wrong ? 0 : 1, //只要有一道是错的就是错的
            answerContent : {
                type : 0,
                userSelectedIndex : answerUser,
                rightSelectedIndex : answerAll,
                answer : right
            }
        };
    },
    //外部获取保存对错的结果
    getResult : function(){
        tag = 1;
        main.opt.liClickFn( JSON.stringify( main.exports ) );
    },

    scrollToAnalysis:function(){
        var questionHeight=$(".right_answers").offset().top;
        //var contentInfoHeight=$(".contentInfo").offset().top;

        //if(contentInfoHeight>questionHeight){
            JSNativeBridge.send("scroll_to_analysis",{'offset':questionHeight});
        //}
    },

    showAnalysis: function(data) {
        $('.contentInfo.none').removeClass('none');
        $(".answer li").off();

        if(main.problemType == QuestionType.LongAnswer){
            common.showAnaByLA();
        }

        if(main.problemType != QuestionType.LongAnswer){//单词题可看做选择题的子类，继承其相应特性
            var aA = $('.answer li a');
            if(!!data){ //如果这次有记录
                //渲染上次选择的和正确的选项
                for(var i=0,len = aA.length; i<len; i++){
                    if( i === data.userSelectedIndex )
                        aA[i].className = cfgSet.style.wrong;
                };
            };
            $('.answer ul li.right a')[0].className = cfgSet.style.right;
        };
        main.resizeEqSymbol();
        //如果结果展示的内容为空，那就不显示
        $('.accordion > article > div').each(function(i,e){
            if( e.innerHTML == ''){
                $(e).closest('.accordion').remove();
            }
        });
    },

    showQuestion: function (){
            //在模拟考显示上次的答题记录，如果直接用户没有操作就，者main。exports没有数据，所以要数据要重新保存;
            if(main.userAnswer) {
                userSelect = main.userAnswer.userSelectedIndex;
                if(userSelect && JSON.stringify(userSelect) != '[""]') {
                    main.exports.answerContent = main.userAnswer;
                    main.exports.result = typeof main.userAnswer.answer === 'object'? (main.userAnswer.answer).toString() : main.userAnswer.answer;
                }
            }
            main.resizeEqSymbol();
        },
    genQuestionTypeTPL:function(){
        main.problemType =parseInt($(".questionType").attr("type").trim());
        switch (main.problemType){
            case QuestionType.EnglishWord:
                main.genWordAnalysis();
                break;
            case QuestionType.LongAnswer:
                main.genLongAnswerTPL();
                break;
            case QuestionType.ReadingComprehension:
                main.genReadingComprehenTPL();
                break;
            case QuestionType.Cloze:
                main.genClozeTPL();
                break;
            default :break;
        }
    },

    genWordAnalysis : function(){
        $(".question").addClass("wordTrain");
        $("#topic_header").remove();
        $("#wordAnalysis").show();
        $("#wordAnalysis").parent().children().not("#wordAnalysis").not(".right_answers").remove();

        var template = '' +
            '<span><%= word%></span>' +
            '<p class="phonetics">' +
                '<% if (!!phonetics.uk) { %>' +
                    '<span>英<%= phonetics.uk%></span>' +
                '<% } %>' +
                '<% if (!!phonetics.uk && !!phonetics.us) { %>' +
                    '<span>&nbsp;&nbsp;</span>' +
                '<% }%>' +
                '<% if (!!phonetics.us) { %>' +
                    '</span><span>美<%= phonetics.us%></span>' +
                '<% } %>' +
            '</p>' +
            '<% _.each(definitions, function(definition) {%>' +
                '<p>' +
                    '<span><%=definition.part_of_speech%></span>' +
                    '<span><%=definition.meaning%></span>' +
                '</p>' +
            '<%})%>';
        var wordDefFunc = _.template(template);
        $("#word_def").html(wordDefFunc(config.wordContent));
    },

    genLongAnswerTPL:function(){
        $(".answer").hide();
        $(".right_answers").hide();
        $(".show_analysis").show();
        $(".show_analysis > span").eq(0).bind("click",function(){
            main.showAnalysis();
            main.bindForAnalysis();
            JSNativeBridge.send("js_msg_longanswer_show_analysis","");
        });
    },

    genReadingComprehenTPL:function(){
        $('body').attr('style', '');
        $(".feedback").hide();
        $(".score").hide();
        $(".question").addClass("reduceMargin");
        $(".answer li > div").addClass("reducePadding");
    },

    genClozeTPL : function(){
        $('body').attr('style', '');
        $(".feedback").hide();
        $(".question").hide();
        $(".answer li > div").addClass("reducePadding");
        $(".answer").addClass("removeBorderTop");
    },

    bindForAnalysis: function() {
        ev.accordion();
        ev.sendFeedback();
        ev.viewKnowledge();
    },

    bindEvents: function() {
        if( main.is_analysis ){
            main.bindForAnalysis();
        }else{
            if(devJudge.isWeixin()||devJudge.isAndroid()||devJudge.isIOS()){
                ev.liTouch();
            }else{
                ev.liClick();
            }
        }
        window.onload = function(){
            if(config.phaseId == PhaseType.MiddleSchool && config.subjectId == SubjectType.Math){
                main.resizeImg();
            }
            ev.initImg(); //如果图片超过60px就放缩小图片高度，提高选项卡的清晰度;
            ev.initCanvas();
        };

         $('.knowledge_header').on('click', function(){
             if(config.subjectId!=SubjectType.English) {
                 main.opt.viewKnowledge(this.id);
             }
     	});

     	$('.degree').on('click', function(){
     		main.opt.onDegreeClick(this.id);
     	});

        $(".tip_info, .tip_info_long_ans").on('click', function(e){
            $(this).hide();
        });

        $("#favor_btn").on('click', function(e){
            var _thisImg=$(this).children("img");
            $("#favor_tip").hide();
            if($(this).attr('class') == "mark") {
                $(this).attr('class', 'unmark');
                //_thisImg.attr("src",_thisImg.attr("src").replace(/favor\.png/,"unfavor.png"));
                _thisImg.eq(0).show();
                _thisImg.eq(1).hide();
                JSNativeBridge.send('uncollectProblem');
            } else {
                $(this).attr('class', 'mark');
                //_thisImg.attr("src",_thisImg.attr("src").replace(/unfavor\.png/,"favor.png"));
                _thisImg.eq(1).show();
                _thisImg.eq(0).hide();
                JSNativeBridge.send('collectProblem');
            }
        })
    },

    onNativeMessage: function(msg_id, msg_content) {
        switch(msg_id) {
            case "show_favor_tip":
                $("#favor_tip").show();
                break;
            case "show_discuss_tip":
                if(main.problemType == QuestionType.LongAnswer){
                    $(".tip_info_long_ans").show();
                }else {
                    $("#discuss_tip").show();
                }
                break;
            case "collectProblem":
                $("#favor_btn").attr('class', 'mark');
                $("#favor_btn").children("img").eq(1).show();
                $("#favor_btn").children("img").eq(0).hide();
                break;
            case "uncollectProblem":
                $("#favor_btn").attr('class', 'unmark');
                $("#favor_btn").children("img").eq(0).show();
                $("#favor_btn").children("img").eq(1).hide();
                break;
            case "showAnalysis" :
                main.bindForAnalysis();
                main.showAnalysis();
                break;
            case "setCommentNum" :
    	        $(".cGreen").text( msg_content);
                break;
            case "setProblemIndex" :
                $("#topic_index").text(msg_content+".");
                break;
            case "client_msg_style_mode":
                if(msg_content.style_mode=="day_mode" ){
                    StyleModeChange.dayMode();
                }else{
                    StyleModeChange.nightMode();
                }
                break;
            case "client_msg_clear_touch_active":
                $(".answer li").removeClass("ans_touched");
                break;
            case "client_msg_hide_discuss_tip":
                $("#discuss_tip, .tip_info_long_ans").hide();
                break;
            default:
                break;
        }
    },

    //添加上次没做完题目的数据
    showUserAnswer : function(){
        //缓存里面有内容
        if( main.problemType != QuestionType.LongAnswer){//单词题为选择题子类，继承其特性
            var index =  main.userAnswer.userSelectedIndex;
            try{ //用户可能没有输入
                $('.answer li a')[index].className = cfgSet.style.active;
            }catch(e){}
        }
    },

    init : function(){
        main.genQuestionTypeTPL();
        main.is_analysis = config.isAnalyse == true ? true : false;
        main.isExamination = config.type; // 0是同步练， 1 是模拟考
        try {
            main.userAnswer = config.userAnswerContent ? JSON.parse(config.userAnswerContent): '';
        } catch(e){ }
        main.rangeDom();//修改美化DOM结构
        if(!main.isExamination){
            $(".score").hide();
        } else {
            $(".degree").hide();
        }
        if( main.is_analysis ){
            main.showAnalysis(main.userAnswer);
        }else{
            main.showQuestion();
        }
        if(!config.showCommentBtn || main.problemType == QuestionType.EnglishWord) {
            $(".feedback").hide();
            $(".discuss").hide();
        }
        if(!config.showFavorBtn) {
            $("#favor_btn").remove();
            $("#favor_tip").remove();
        }
        if(config.showDiscussTip) {
            $("#discuss_tip").show();
        }
        if(config.subjectId==SubjectType.English){
            $('body').attr('style', 'font-family:symbol');
            $(".degree").remove();
            $(".knowledge_point").removeClass("knowledge_point");
            $(".knowledge_header_name").removeClass("knowledge_header_name");
            //$("body").undelegate(".knowledge_header","click");        //此句无效
        }
        if(config.hideDegree) {
            $(".degree").remove();
        }
        //如果有数据加载进来，说明上次有结果，那就展示
        if( main.userAnswer && !main.is_analysis){ //如果缓存有数据
            main.showUserAnswer()
        };
        if (config.showFavorTip) {
            $("#favor_tip").show();
        }
        if(!config.isCustomFont){
            $('body').attr('style', '');                        //适配步步高
        }
        if(config.styleMode == "night_mode"){
            StyleModeChange.nightMode();
        }else{
            StyleModeChange.dayMode();
        }
    },

    load : function(opt){
        main.opt = {
            zoomImg : opt.zoomImg || function(){},
            liClickFn : opt.liClickFn  || function(){},
            analysClick : opt.analysClick || function(){},
            sendFeedback : opt.sendFeedback || function(){},
            viewKnowledge : opt.viewKnowledge || function(){},
            loadFinish : opt.loadFinish || function(){},
            onUserAnswered: opt.onUserAnswered || function() {},
            onDegreeClick: opt.onDegreeClick || function() {}
        };
        main.init();
        main.bindEvents();
        JSNativeBridge.init(main.onNativeMessage);
        window.uplusInterface.loadFinish();
    }
};
